Index: issm/trunk/src/m/classes/solidearthsolution.js
===================================================================
--- issm/trunk/src/m/classes/solidearthsolution.js	(revision 26744)
+++ issm/trunk/src/m/classes/solidearthsolution.js	(revision 26744)
@@ -0,0 +1,77 @@
+class solidearthsolution {//{{{
+	/**
+	 * SOLIDEARTHSOLUTION class definition
+	 *
+	 * Usage:
+	 *     solidearthsolution = solidearthsolution();
+	 */
+	constructor() {//{{{
+		this.displacementeast	= [];
+		this.displacementnorth	= [];
+		this.displacementup		= [];
+		this.geoid				= [];
+
+		let nargs = arguments.length;
+		if (nargs == 0) {
+			this.setdefaultparameters();
+		} else {
+			error('constructor not supported');
+		}
+	} //}}}
+
+	setdefaultparameters() {//{{{
+		this.displacementeast	= [];
+		this.displacementnorth	= [];
+		this.displacementup		= [];
+		this.geoid				= [];
+	} //}}}
+
+	checkconsistency(md, solution, analyses) {//{{{
+		md = checkfield(md, 'fieldname', 'solidearth.external.displacementeast', 'Inf', 1, 'timeseries', 1);
+		md = checkfield(md, 'fieldname', 'solidearth.external.displacementnorth', 'Inf', 1, 'timeseries', 1);
+		md = checkfield(md, 'fieldname', 'solidearth.external.displacementup', 'Inf', 1, 'timeseries', 1);
+		md = checkfield(md, 'fieldname', 'solidearth.external.geoid', 'Inf', 1, 'timeseries', 1);
+
+		return md;
+	} //}}}
+
+	disp() {//{{{
+		console.log('WARNING: solidearthsolution::disp is not yet implemented');
+	} //}}}
+
+	marshall(md, prefix, fid) {//{{{
+		let yts = md.constants.yts;
+
+		// Transform our time series into time series rates
+		let displacementeast_rate	= [];
+		let displacementnorth_rate	= [];
+		let displacementup_rate		= [];
+		let geoid_rate				= [];
+		if (size(this.displacementeast, 1) == 1) {
+			disp('External solidearthsolution warning: only one time step provided, assuming the values are rates per year');
+			displacementeast_rate	= [this.displacementeast; 0];
+			displacementnorth_rate	= [this.displacementnorth; 0];
+			displacementup_rate		= [this.displacementup; 0];
+			geoid_rate				= [this.geoid; 0];
+		} else {
+			let time = this.displacementeast[end, :];
+			let dt = diff(time, 1, 2);
+			displacementeast_rate = diff(this.displacementeast[0:-1,:], 1, 2) ./ dt;
+			displacementeast_rate[end + 1, :] = time[0:-1];
+			displacementnorth_rate = diff(this.displacementnorth_rate[0:-1,:], 1, 2) ./ dt;
+			displacementnorth_rate[end + 1, :] = time[0:-1];
+			displacementup_rate = diff(this.displacementup_rate[0:-1,:], 1, 2) ./ dt;
+			displacementup_rate[end + 1, :] = time[0:-1];
+			geoid_rate = diff(this.geoid_rate[0:-1,:], 1, 2) ./ dt;
+			geoid_rate[end + 1, :] = tgeoid_rateime[0:-1];
+		}
+
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'displacementeast', 'data', displacementeast_rate, 'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementeast', 'mattype', 1, 'scale', 1 / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'displacementup', 'data', displacementup_rate, 'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementup', 'mattype', 1, 'scale', 1 / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'displacementnorth', 'data', displacementnorth_rate, 'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementnorth', 'mattype', 1, 'scale', 1 / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'geoid', 'data', geoid_rate, 'format', 'DoubleMat', 'name', 'md.solidearth.external.geoid', 'mattype', 1, 'scale', 1 / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+	} //}}}
+
+	extrude(md) {//{{{
+	} //}}}
+} //}}}
Index: issm/trunk/src/m/classes/solidearthsolution.m
===================================================================
--- issm/trunk/src/m/classes/solidearthsolution.m	(revision 25994)
+++ issm/trunk/src/m/classes/solidearthsolution.m	(revision 26744)
@@ -10,5 +10,4 @@
 		displacementup=[];
 		geoid=[];
-		barystaticsealevel=[];
 	end
 	methods
@@ -21,4 +20,12 @@
 			end
 		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('%s','         units for time series is (yr)'));
+			fielddisplay(self,'displacementeast','solid-Earth Eastwards bedrock displacement series (m)');
+			fielddisplay(self,'displacementnorth','solid-Earth Northwards bedrock displacement time series (m)');
+			fielddisplay(self,'displacementup','solid-Earth bedrock uplift time series (m)');
+			fielddisplay(self,'geoid','solid-Earth geoid time series (m)');
+
+		end % }}}
 		function self = setdefaultparameters(self) % {{{
 	
@@ -27,5 +34,4 @@
 			self.displacementup=[];
 			self.geoid=[];
-			self.barystaticsealevel=[];
 	
 		end % }}}
@@ -36,23 +42,35 @@
 			md = checkfield(md,'fieldname','solidearth.external.displacementup','Inf',1,'timeseries',1);
 			md = checkfield(md,'fieldname','solidearth.external.geoid','Inf',1,'timeseries',1);
-			md = checkfield(md,'fieldname','solidearth.external.barystaticsealevel','Inf',1,'timeseries',1);
-
-		end % }}}
-		function disp(self) % {{{
-			fielddisplay(self,'displacementeast','solid-Earth Eastwards bedrock motion (m/yr)');
-			fielddisplay(self,'displacementnorth','solid-Earth Northwards bedrock motion (m/yr)');
-			fielddisplay(self,'displacementup','solid-Earth bedrock uplift rate (m/yr)');
-			fielddisplay(self,'geoid','solid-Earth geoid motion (m/yr)');
-			fielddisplay(self,'barystaticsealevel','barystatic absolute sea-level rate (m/yr)');
 
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
 			yts=md.constants.yts;
-			WriteData(fid,prefix,'object',self,'class','solidearthsolution','fieldname','displacementeast','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-			WriteData(fid,prefix,'object',self,'class','solidearthsolution','fieldname','displacementnorth','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-			WriteData(fid,prefix,'object',self,'class','solidearthsolution','fieldname','displacementup','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-			WriteData(fid,prefix,'object',self,'class','solidearthsolution','fieldname','geoid','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-			WriteData(fid,prefix,'object',self,'class','solidearthsolution','fieldname','barystaticsealevel','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-	
+
+			%transform our time series into time series rates 
+			if size(self.displacementeast,2)==1
+				disp('External solidearthsolution warning: only one time step provided, assuming the values are rates per year');
+				displacementeast_rate=[self.displacementeast;0];
+				displacementnorth_rate=[self.displacementnorth;0];
+				displacementup_rate=[self.displacementup;0];
+				geoid_rate=[self.geoid;0];
+			else
+				time=self.displacementeast(end,:);
+				dt=diff(time,1,2);
+				displacementeast_rate=diff(self.displacementeast(1:end-1,:),1,2)./dt;
+				displacementeast_rate(end+1,:)=time(1:end-1);
+				displacementnorth_rate=diff(self.displacementnorth(1:end-1,:),1,2)./dt;
+				displacementnorth_rate(end+1,:)=time(1:end-1);
+				displacementup_rate=diff(self.displacementup(1:end-1,:),1,2)./dt;
+				displacementup_rate(end+1,:)=time(1:end-1);
+				geoid_rate=diff(self.geoid(1:end-1,:),1,2)./dt;
+				geoid_rate(end+1,:)=time(1:end-1);
+			end
+
+			WriteData(fid, prefix, 'name', 'md.solidearth.external.nature', 'data', 0, 'format', 'Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','displacementeast','data',displacementeast_rate,'format','DoubleMat','name', 'md.solidearth.external.displacementeast','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts);
+			WriteData(fid,prefix,'object',self,'fieldname','displacementup','data',displacementup_rate,'format','DoubleMat','name', 'md.solidearth.external.displacementup','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts);
+			WriteData(fid,prefix,'object',self,'fieldname','displacementnorth','data',displacementnorth_rate,'format','DoubleMat','name', 'md.solidearth.external.displacementnorth','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts);
+			WriteData(fid,prefix,'object',self,'fieldname','geoid','data',geoid_rate,'format','DoubleMat','name', 'md.solidearth.external.geoid','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts);
+			
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
@@ -61,5 +79,4 @@
 			writejs1Darray(fid,[modelname '.solidearth.external.displacementup'],self.displacementup);
 			writejs1Darray(fid,[modelname '.solidearth.external.geoid'],self.geoid);
-			writejs1Darray(fid,[modelname '.solidearth.external.barystaticsealevel'],self.barystaticsealevel);
 		end % }}}
 		function self = extrude(self,md) % {{{
Index: issm/trunk/src/m/classes/solidearthsolution.py
===================================================================
--- issm/trunk/src/m/classes/solidearthsolution.py	(revision 26744)
+++ issm/trunk/src/m/classes/solidearthsolution.py	(revision 26744)
@@ -0,0 +1,85 @@
+import numpy as np
+
+from checkfield import checkfield
+from fielddisplay import fielddisplay
+from WriteData import WriteData
+
+
+class solidearthsolution(object):
+    """SOLIDEARTHSOLUTION class definition
+
+    Usage:
+        solidearthsolution = solidearthsolution()
+    """
+
+    def __init__(self, *args):  # {{{
+        self.displacementeast = []
+        self.displacementnorth = []
+        self.displacementup = []
+        self.geoid = []
+
+        if len(args) == 0:
+            self.setdefaultparameters()
+        else:
+            raise RuntimeError('constructor not supported')
+    # }}}
+
+    def __repr__(self):  # {{{
+        s = '         units for time series is (yr)\n'
+        s += '{}\n'.format(fielddisplay(self, 'displacementeast', 'solid-Earth Eastwards bedrock displacement series (m)'))
+        s += '{}\n'.format(fielddisplay(self, 'displacementnorth', 'solid-Earth Northwards bedrock displacement time series (m)'))
+        s += '{}\n'.format(fielddisplay(self, 'displacementup', 'solid-Earth bedrock uplift time series (m)'))
+        s += '{}\n'.format(fielddisplay(self, 'geoid', 'solid-Earth geoid time series (m)'))
+
+        return s
+    # }}}
+
+    def setdefaultparameters(self):  # {{{
+        self.displacementeast = []
+        self.displacementnorth = []
+        self.displacementup = []
+        self.geoid = []
+    # }}}
+
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        md = checkfield(md, 'fieldname', 'solidearth.external.displacementeast', 'Inf', 1, 'timeseries', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.external.displacementnorth', 'Inf', 1, 'timeseries', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.external.displacementup', 'Inf', 1, 'timeseries', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.external.geoid', 'Inf', 1, 'timeseries', 1)
+    # }}}
+
+    def marshall(self, prefix, md, fid):  # {{{
+        yts = md.constants.yts
+
+        print('sadjsda')
+        exit()
+
+        # Transform our time series into time series rates
+        if np.shape(self.displacementeast)[1] == 1:
+            print('solidearthsolution.py::marshall: Warning: only one time step provided, assuming the values are rates per year')
+            displacementeast_rate = np.append(np.array(self.displacementeast).reshape(-1, 1), 0)
+            displacementnorth_rate = np.append(np.array(self.displacementnorth).reshape(-1, 1), 0)
+            displacementup_rate = np.append(np.array(self.displacementup).reshape(-1, 1), 0)
+            geoid_rate = np.append(np.array(self.geoid).reshape(-1, 1), 0)
+        else:
+            time = self.displacementeast[-1, :]
+            dt = np.diff(time, axis=0)
+            displacementeast_rate = np.diff(self.displacementeast[0:-2, :], 1, 1) / dt
+            displacementeast_rate = np.append(displacementeast_rate,time[:-1].reshape(1,-1),axis=0)
+            displacementnorth_rate = np.diff(self.displacementnorth[0:-2, :], 1, 1) / dt
+            displacementnorth_rate = np.append(displacementnorth_rate,time[:-1].reshape(1,-1),axis=0)
+            displacementup_rate = np.diff(self.displacementup[0:-2, :], 1, 1) / dt
+            displacementup_rate = np.append(displacementup_rate,time[:-1].reshape(1,-1),axis=0)
+            geoid_rate = np.diff(self.geoid[0:-2, :], 1, 1) / dt
+            geoid_rate = np.append(geoid_rate,time[:-1].reshape(1,-1),axis=0)
+
+        WriteData(fid, prefix, 'name', 'md.solidearth.external.nature', 'data', 0, 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'displacementeast', 'data', displacementeast_rate, 'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementeast', 'mattype', 1, 'scale', 1 / yts,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'displacementup', 'data', displacementup_rate,'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementup', 'mattype', 1, 'scale', 1 / yts,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'displacementnorth', 'data', displacementnorth_rate,'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementnorth', 'mattype', 1, 'scale', 1 / yts,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'geoid', 'data', geoid_rate,'format', 'DoubleMat', 'name', 'md.solidearth.external.geoid', 'mattype', 1, 'scale', 1 / yts,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+    # }}}
+
+    def extrude(self, md):  # {{{
+        return self
+    # }}}
Index: issm/trunk/src/m/classes/stochasticforcing.m
===================================================================
--- issm/trunk/src/m/classes/stochasticforcing.m	(revision 26744)
+++ issm/trunk/src/m/classes/stochasticforcing.m	(revision 26744)
@@ -0,0 +1,210 @@
+%STOCHASTICFORCING class definition
+%
+%   Usage:
+%      stochasticforcing=stochasticforcing();
+
+classdef stochasticforcing
+	properties (SetAccess=public)
+		isstochasticforcing	= 0;
+		fields					= NaN;
+		defaultdimension		= 0;
+		default_id				= NaN;
+		covariance				= NaN;
+		randomflag				= 1;
+	end
+	methods
+		function self = stochasticforcing(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = extrude(self,md) % {{{
+			%Nothing for now
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+			self.isstochasticforcing	= 0; %stochasticforcing is turned off by default
+			self.randomflag				= 1; %true randomness is implemented by default
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			%Early return
+			if ~self.isstochasticforcing, return; end
+
+			num_fields = numel(self.fields);
+
+			%Check that covariance matrix is positive definite
+			try
+				chol(self.covariance);
+			catch
+				error('md.stochasticforcing.covariance is not positive definite');
+			end
+
+			%Check that all fields agree with the corresponding md class and if any field needs the default params
+			checkdefaults	= false; %need to check defaults only if one of the fields does not have its own dimensionality
+			structstoch		= structstochforcing();
+			for field=self.fields
+				%Checking agreement of classes
+				if(contains(field,'SMB'))
+					mdname = structstoch.mdnames(find(strcmp(structstoch.fields,char(field))));
+					if~(isequal(class(md.smb),char(mdname)))
+						error('md.smb does not agree with stochasticforcing field %s', char(field));
+					end
+				end
+				if(contains(field,'FrontalForcings'))
+					mdname = structstoch.mdnames(find(strcmp(structstoch.fields,char(field))));
+					if~(isequal(class(md.frontalforcings),char(mdname)))
+						error('md.frontalforcings does not agree with stochasticforcing field %s', char(field));
+					end
+				end
+				if(contains(field,'Calving'))
+					mdname = structstoch.mdnames(find(strcmp(structstoch.fields,char(field))));
+					if~(isequal(class(md.calving),char(mdname)))
+						error('md.calving does not agree with stochasticforcing field %s', char(field));
+					end
+				end
+				if(contains(field,'BasalforcingsFloatingice'))
+					mdname = structstoch.mdnames(find(strcmp(structstoch.fields,char(field))));
+					if~(isequal(class(md.basalforcings),char(mdname)))
+						error('md.basalforcings does not agree with stochasticforcing field %s', char(field));
+					end
+				end
+				if(contains(field,'WaterPressure'))
+               mdname = structstoch.mdnames(find(strcmp(structstoch.fields,char(field))));
+               if~(isequal(class(md.friction),char(mdname)))
+                  error('stochasticforcing field %s is only implemented for default friction', char(field));
+               end
+               if(md.friction.coupling~=0 && md.friction.coupling~=1 && md.friction.coupling~=2)
+                  error('stochasticforcing field %s is only implemented for cases md.friction.coupling 0 or 1 or 2', char(field));
+               end
+               if(any(md.friction.q==0))
+                  error('stochasticforcing field %s requires non-zero q exponent',char(field));
+               end
+            end
+				%Checking for specific dimensions
+				if ~(strcmp(field,'SMBautoregression') || strcmp(field,'FrontalForcingsRignotAutoregression'))
+					checkdefaults = true; %field with non-specific dimensionality
+				end
+			end
+
+			%Retrieve sum of all the field dimensionalities
+			size_tot	= self.defaultdimension*num_fields;
+			indSMBar	= -1; %about to check for index of SMBautoregression
+			indTFar	= -1; %about to check for index of FrontalForcingsRignotAutoregression
+			if any(contains(self.fields,'SMBautoregression'))
+				size_tot = size_tot-self.defaultdimension+md.smb.num_basins;
+				indSMBar = find(contains(self.fields,'SMBautoregression')); %index of SMBar, now check for consistency with TFar timestep (08Nov2021)
+			end
+			if any(contains(self.fields,'FrontalForcingsRignotAutoregression'))
+				size_tot	= size_tot-self.defaultdimension+md.frontalforcings.num_basins;
+				indTFar	= find(contains(self.fields,'FrontalForcingsRignotAutoregression')); %index of TFar, now check for consistency with SMBar timestep (08Nov2021)
+			end
+
+			if(indSMBar~=-1 && indTFar~=-1) %both autoregressive models are used: check autoregressive time step consistency
+				if((md.smb.ar_timestep~=md.frontalforcings.ar_timestep) && any(self.covariance(1+sum(self.dimensions(1:indSMBar-1)):sum(self.dimensions(1:indSMBar)),1+sum(self.dimensions(1:indTFar-1)):sum(self.dimensions(1:indTFar))))~=0)
+					error('SMBautoregression and FrontalForcingsRignotAutoregression have different ar_timestep and non-zero covariance');
+				end
+			end
+
+			md = checkfield(md,'fieldname','stochasticforcing.isstochasticforcing','values',[0 1]);
+			md = checkfield(md,'fieldname','stochasticforcing.fields','numel',num_fields,'cell',1,'values',supportedstochforcings());
+			md = checkfield(md,'fieldname','stochasticforcing.covariance','NaN',1,'Inf',1,'size',[size_tot,size_tot]); %global covariance matrix
+			md = checkfield(md,'fieldname','stochasticforcing.randomflag','numel',[1],'values',[0 1]);
+			if(checkdefaults) %need to check the defaults
+				md = checkfield(md,'fieldname','stochasticforcing.defaultdimension','numel',1,'NaN',1,'Inf',1,'>',0);
+				md = checkfield(md,'fieldname','stochasticforcing.default_id','Inf',1,'>=',0,'<=',self.defaultdimension,'size',[md.mesh.numberofelements,1]);
+			end
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   stochasticforcing parameters:'));
+			fielddisplay(self,'isstochasticforcing','is stochasticity activated?');
+			fielddisplay(self,'fields','fields with stochasticity applied, ex: {''SMBautoregression''}, or {''FrontalForcingsRignotAutoregression''}');
+			fielddisplay(self,'defaultdimension','dimensionality of the noise terms (does not apply to fields with their specific dimension)');
+			fielddisplay(self,'default_id','id of each element for partitioning of the noise terms (does not apply to fields with their specific partition)');
+			fielddisplay(self,'covariance','covariance matrix for within- and between-fields covariance (units must be squared field units)');
+			fielddisplay(self,'randomflag','whether to apply real randomness (true) or pseudo-randomness with fixed seed (false)');
+			disp('Available fields:');
+			for field=supportedstochforcings()
+				fprintf('   %s\n',string(field));
+			end
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+
+			yts=md.constants.yts;
+			num_fields = numel(self.fields);
+
+			WriteData(fid,prefix,'object',self,'fieldname','isstochasticforcing','format','Boolean');
+			if ~self.isstochasticforcing 
+				return
+			else
+
+				%Retrieve dimensionality of each field
+				dimensions = self.defaultdimension*ones(1,num_fields);
+				ind = 1;
+				for field=self.fields
+					%Checking for specific dimensions
+					if(strcmp(field,'SMBautoregression'))
+						dimensions(ind) = md.smb.num_basins;
+					end
+					if(strcmp(field,'FrontalForcingsRignotAutoregression'))
+						dimensions(ind) = md.frontalforcings.num_basins;
+					end
+					ind = ind+1;
+				end
+
+				%Scaling covariance matrix (scale column-by-column and row-by-row)
+				scaledfields = {'DefaultCalving','FloatingMeltRate','SMBautoregression'}; %list of fields that need scaling *1/yts
+				tempcovariance = self.covariance; %copy of covariance to avoid writing back in member variable
+				for i=1:num_fields
+					if any(strcmp(scaledfields,self.fields(i)))
+						inds = [1+sum(dimensions(1:i-1)):1:sum(dimensions(1:i))];
+						for row=inds %scale rows corresponding to scaled field
+							tempcovariance(row,:) = 1./yts*tempcovariance(row,:);
+						end
+						for col=inds %scale columns corresponding to scaled field
+							tempcovariance(:,col) = 1./yts*tempcovariance(:,col);
+						end
+					end
+				end
+				%Set dummy default_id vector if defaults not used
+				if isnan(self.default_id)
+					self.default_id = zeros(md.mesh.numberofelements,1);
+				end
+				WriteData(fid,prefix,'data',num_fields,'name','md.stochasticforcing.num_fields','format','Integer');
+				WriteData(fid,prefix,'object',self,'fieldname','fields','format','StringArray');
+				WriteData(fid,prefix,'data',dimensions,'name','md.stochasticforcing.dimensions','format','IntMat');
+				WriteData(fid,prefix,'object',self,'fieldname','default_id','data',self.default_id-1,'format','IntMat','mattype',2); %0-indexed
+				WriteData(fid,prefix,'object',self,'fieldname','defaultdimension','format','Integer');
+				WriteData(fid,prefix,'data',tempcovariance,'name','md.stochasticforcing.covariance','format','DoubleMat');
+				WriteData(fid,prefix,'object',self,'fieldname','randomflag','format','Boolean');
+			end
+		end % }}}
+	end
+end
+function list = supportedstochforcings() % {{{
+	% Defines list of fields supported
+	% by the class md.stochasticforcing
+
+	list = structstochforcing();
+	list = list.fields;
+end % }}}
+function structure = structstochforcing() % {{{
+	% Defines structure with list of fields
+	% supported and corresponding md names
+	structure.fields = {...
+		'DefaultCalving',...
+		'FloatingMeltRate',...
+		'FrictionWaterPressure',...
+		'FrontalForcingsRignotAutoregression',...
+		'SMBautoregression'
+		};
+	structure.mdnames = {...
+		'calving',...
+		'basalforcings',...
+		'friction',...
+		'frontalforcingsrignotautoregression',...
+		'SMBautoregression'
+	};
+end % }}}
